#include <iostream>

using namespace std;

int main()
{
    int n,q;
    cin>>n>>q;
    int d[n],p[n];
    for(int i=0;i<n;i++)
    {
        cin>>d[i]>>p[i];
    }
    for(int i=0;i<q;i++)
    {
        int hp;
        cin>>hp;
        if (p[0]==0)
        {
            int i;
            for(i=0;i<n;i++)
            {
                if(hp==0) break;
                hp-=d[i];
            }
            if(hp>0) cout<<-1<<'\n';
            else cout<<i<<'\n';
        }
        else{
            int i,pukupno=0;
            for(i=0;i<n;i++)
            {
                if(hp==0) break;
                pukupno+=p[i];
                hp-=pukupno;
            }
            if(hp>0) cout<<-1<<'\n';
            else cout<<i<<'\n';
        }
    }
}